/*! @file
 * @brief
 * test for modulo/numbertheoretic functions (performance, correctness)
 */

// only for testing the functions


#include "modulo.cc"

using namespace std;
using namespace numtheory;


bool test01()
{
  unsigned int v=0;
  for (unsigned int p=10000001; p<10020000; p+=2)
   {
     if (!probab_prime(p)) continue;
     for (unsigned int a=7000000 ; a<7015000; ++a)
      //v|=powmod(a,p-2,p);
      v|=invmod(a,p);
   }
  cout << v << endl;
  return true;
}

int main()
{
 //test01();
 //return 0;

#if 0
 // test oddgcd
 cout << oddgcd(100,200) << endl;
 cout << oddgcd(20,81) << endl;
 cout << oddgcd(35,25) << " " << oddgcd(25,35) << endl;
 cout << oddgcd(5551150,11350) << " " << oddgcd(5551150,11350) << endl;
 return 1;
#endif

#if 1
 while(true)
  {
    unsigned int x,m;
    cout << "x= " << flush; cin >> x;
    cout << "m= " << flush; cin >> m;
    cout << "coprime: " << coprime(x,m) << endl;
    unsigned int y;
    y=invmod(x,m);
    cout << "invmod: " << y << " = 1/" << x << " (mod " << m << ")" << endl;
    cout << "valid? " << (mulmod(x,y,m)==1) << endl;
    y=bininvmod(x,m);
    cout << "bininvmod: " << y << " = 1/" << x << " (mod " << m << ")" << endl;
    cout << "valid? " << (mulmod(x,y,m)==1) << endl;
    y=montgominvmod(x,m);
    cout << "montgominvmod: " << y << " = 1/" << x << " (mod " << m << ")" << endl;
    cout << "valid? " << (mulmod(x,y,m)==1) << endl;
  }
#endif

#if 0
 signed int a,m;
  cout << "a= " << flush; cin >> a;
  cout << "m= " << flush; cin >> m;
//  cout << a%m << " <-> " << normalized_signed_mod(a,m) << endl;
  a=normalized_signed_mod(a,m);
  cout << a << endl;
#endif
  return 0;
}
